
namespace iupim

include std/dll.e
include std/machine.e

atom iupim = open_dll({ "iupim.dll", "libiupim.so", "libiupim.dylib" })


constant -- function delcarations
	xIupLoadImage                     = define_c_func( iupim, "+IupLoadImage", {C_POINTER}, C_POINTER ),
	xIupSaveImage                     = define_c_func( iupim, "+IupSaveImage", {C_POINTER,C_POINTER,C_POINTER}, C_INT ),
	xIupGetNativeHandleImage          = define_c_func( iupim, "+IupGetNativeHandleImage", {C_POINTER}, C_POINTER ),
	xIupGetImageNativeHandle          = define_c_func( iupim, "+IupGetImageNativeHandle", {C_POINTER}, C_POINTER ),
	xIupImageFromImImage              = define_c_func( iupim, "+IupImageFromImImage", {C_POINTER}, C_POINTER ),
$

--Ihandle* IupLoadImage(const char* file_name);
public function IupLoadImage(object file_name = NULL)
	if sequence(file_name) then file_name = allocate_string(file_name) end if
	atom result = c_func( xIupLoadImage, {file_name} )
	return result
end function

--int IupSaveImage(Ihandle* ih, const char* file_name, const char* format);
public function IupSaveImage(atom ih, object file_name = NULL, object format = NULL)
	if sequence(file_name) then file_name = allocate_string(file_name) end if
	if sequence(format) then format = allocate_string(format) end if
	atom result = c_func( xIupSaveImage, {ih,file_name,format} )
	return result
end function

--imImage* IupGetNativeHandleImage(void* handle);
public function IupGetNativeHandleImage(atom handle)
	atom result = c_func( xIupGetNativeHandleImage, {handle} )
	return result
end function

--void* IupGetImageNativeHandle(const imImage* image);
public function IupGetImageNativeHandle(atom image)
	atom result = c_func( xIupGetImageNativeHandle, {image} )
	return result
end function

--Ihandle* IupImageFromImImage(const imImage* image);
public function IupImageFromImImage(atom image)
	atom result = c_func( xIupImageFromImImage, {image} )
	return result
end function


